Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::BooleanScorer2 Class Reference

See the description in BooleanScorer, comparing BooleanScorer & BooleanScorer2. More...

`#include <BooleanScorer2.h>`

Inheritance diagram for Lucene::BooleanScorer2:

## Public Member Functions

| BooleanScorer2 (SimilarityPtr similarity, int32_t minNrShouldMatch, Collection< ScorerPtr > required, Collection< ScorerPtr > prohibited, Collection< ScorerPtr > optional)
| Creates a Scorer with the given similarity and lists of required, prohibited and optional scorers. In no required scorers are added, at least one of the optional scorers will have to match during the search. More...
virtual | ~BooleanScorer2 ()
virtual String | getClassName ()
boost::shared_ptr< BooleanScorer2 > | shared_from_this ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual void | score (CollectorPtr collector)
| Scores and collects all matching documents. More...
virtual bool | score (CollectorPtr collector, int32_t max, int32_t firstDocID)
| Collects matching documents in a range. Hook for optimization. Note, firstDocID is added to ensure that nextDoc() was called before this method. More...
virtual int32_t | docID ()
| Returns the following: More...
virtual int32_t | nextDoc ()
| Advances to the next document in the set and returns the doc it is currently on, or NO_MORE_DOCS if there are no more docs in the set. More...
virtual double | score ()
| Returns the score of the current document matching the query. Initially invalid, until nextDoc() or advance(int32_t) is called the first time, or when called from within Collector#collect. More...
virtual int32_t | advance (int32_t target)
| Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or NO_MORE_DOCS if there are no more docs in the set. More...
Public Member Functions inherited from Lucene::Scorer
| Scorer (SimilarityPtr similarity)
| Constructs a Scorer. More...
virtual | ~Scorer ()
boost::shared_ptr< Scorer > | shared_from_this ()
SimilarityPtr | getSimilarity ()
| Returns the Similarity implementation used by this scorer. More...
Public Member Functions inherited from Lucene::DocIdSetIterator
virtual | ~DocIdSetIterator ()
boost::shared_ptr < DocIdSetIterator > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual LuceneObjectPtr | clone (LuceneObjectPtr other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (LuceneObjectPtr other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (LuceneObjectPtr other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Scorer
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::DocIdSetIterator
static String | _getClassName ()

## Protected Member Functions

ScorerPtr | countingDisjunctionSumScorer (Collection< ScorerPtr > scorers, int32_t minNrShouldMatch)
ScorerPtr | countingConjunctionSumScorer (Collection< ScorerPtr > requiredScorers)
ScorerPtr | dualConjunctionSumScorer (ScorerPtr req1, ScorerPtr req2)
ScorerPtr | makeCountingSumScorer ()
| Returns the scorer to be used for match counting and score summing. Uses requiredScorers, optionalScorers and prohibitedScorers. More...
ScorerPtr | makeCountingSumScorerNoReq ()
ScorerPtr | makeCountingSumScorerSomeReq ()
ScorerPtr | addProhibitedScorers (ScorerPtr requiredCountingSumScorer)
| Returns the scorer to be used for match counting and score summing. Uses the given required scorer and the prohibitedScorers. More...

## Protected Attributes

Collection< ScorerPtr > | requiredScorers
Collection< ScorerPtr > | optionalScorers
Collection< ScorerPtr > | prohibitedScorers
CoordinatorPtr | coordinator
ScorerPtr | countingSumScorer
| The scorer to which all scoring will be delegated, except for computing and using the coordination factor. More...
int32_t | minNrShouldMatch
int32_t | doc
Protected Attributes inherited from Lucene::Scorer
SimilarityPtr | similarity

## Additional Inherited Members

Static Public Attributes inherited from Lucene::DocIdSetIterator
static const int32_t | NO_MORE_DOCS
| When returned by nextDoc(), advance(int) and docID() it means there are no more docs in the iterator. More...

## Detailed Description

See the description in BooleanScorer, comparing BooleanScorer & BooleanScorer2.

An alternative to BooleanScorer that also allows a minimum number of optional scorers that should match. Implements skipTo(), and has no limitations on the numbers of added scorers. Uses ConjunctionScorer, DisjunctionScorer, ReqOptScorer and ReqExclScorer.

## Constructor & Destructor Documentation

Lucene::BooleanScorer2::BooleanScorer2 | ( | SimilarityPtr | similarity,
|  | int32_t | minNrShouldMatch,
|  | Collection< ScorerPtr > | required,
|  | Collection< ScorerPtr > | prohibited,
|  | Collection< ScorerPtr > | optional
| ) |  |

Creates a Scorer with the given similarity and lists of required, prohibited and optional scorers. In no required scorers are added, at least one of the optional scorers will have to match during the search.

Parameters

  similarity | The similarity to be used.
  minNrShouldMatch | The minimum number of optional added scorers that should match during the search. In case no required scorers are added, at least one of the optional scorers will have to match during the search.
  required | The list of required scorers.
  prohibited | The list of prohibited scorers.
  optional | The list of optional scorers.

virtual Lucene::BooleanScorer2::~BooleanScorer2 | ( | ) |  |

virtual

## Member Function Documentation

static String Lucene::BooleanScorer2::_getClassName | ( | ) |  |

inline static

ScorerPtr Lucene::BooleanScorer2::addProhibitedScorers | ( | ScorerPtr | requiredCountingSumScorer) |  |

protected

Returns the scorer to be used for match counting and score summing. Uses the given required scorer and the prohibitedScorers.

Parameters

  requiredCountingSumScorer | A required scorer already built.

virtual int32_t Lucene::BooleanScorer2::advance | ( | int32_t | target) |  |

virtual

Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or NO_MORE_DOCS if there are no more docs in the set.

Behaves as if written:

    int32_t advance(int32_t target)
    {
        int32_t doc;
        while ((doc = nextDoc()) < target)
        { }
        return doc;
    }

Some implementations are considerably more efficient than that.

NOTE: certain implementations may return a different value (each time) if called several times in a row with the same target.

NOTE: this method may be called with { NO_MORE_DOCS} for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behaviour.

Implements Lucene::DocIdSetIterator.

ScorerPtr Lucene::BooleanScorer2::countingConjunctionSumScorer | ( | Collection< ScorerPtr > | requiredScorers) |  |

protected

ScorerPtr Lucene::BooleanScorer2::countingDisjunctionSumScorer | ( | Collection< ScorerPtr > | scorers,
|  | int32_t | minNrShouldMatch
| ) |  |

protected

virtual int32_t Lucene::BooleanScorer2::docID | ( | ) |  |

virtual

Returns the following:

- -1 or NO_MORE_DOCS if nextDoc() or advance(int) were not called yet.
- NO_MORE_DOCS if the iterator has exhausted.
- Otherwise it should return the doc ID it is currently on.

Implements Lucene::DocIdSetIterator.

ScorerPtr Lucene::BooleanScorer2::dualConjunctionSumScorer | ( | ScorerPtr | req1,
|  | ScorerPtr | req2
| ) |  |

protected

virtual String Lucene::BooleanScorer2::getClassName | ( | ) |  |

inline virtual

Reimplemented from Lucene::Scorer.

virtual void Lucene::BooleanScorer2::initialize | ( | ) |  |

virtual

Called directly after instantiation to create objects that depend on this object being fully constructed.

Reimplemented from Lucene::LuceneObject.

ScorerPtr Lucene::BooleanScorer2::makeCountingSumScorer | ( | ) |  |

protected

Returns the scorer to be used for match counting and score summing. Uses requiredScorers, optionalScorers and prohibitedScorers.

ScorerPtr Lucene::BooleanScorer2::makeCountingSumScorerNoReq | ( | ) |  |

protected

ScorerPtr Lucene::BooleanScorer2::makeCountingSumScorerSomeReq | ( | ) |  |

protected

virtual int32_t Lucene::BooleanScorer2::nextDoc | ( | ) |  |

virtual

Advances to the next document in the set and returns the doc it is currently on, or NO_MORE_DOCS if there are no more docs in the set.

NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behaviour.

Implements Lucene::DocIdSetIterator.

virtual void Lucene::BooleanScorer2::score | ( | CollectorPtr | collector) |  |

virtual

Scores and collects all matching documents.

Parameters

  collector | The collector to which all matching documents are passed through.

Reimplemented from Lucene::Scorer.

virtual bool Lucene::BooleanScorer2::score | ( | CollectorPtr | collector,
|  | int32_t | max,
|  | int32_t | firstDocID
| ) |  |

virtual

Collects matching documents in a range. Hook for optimization. Note, firstDocID is added to ensure that nextDoc() was called before this method.

Parameters

  collector | The collector to which all matching documents are passed.
  max | Do not score documents past this.
  firstDocID | The first document ID (ensures nextDoc() is called before this method.

Returns
  true if more matching documents may remain.

Reimplemented from Lucene::Scorer.

virtual double Lucene::BooleanScorer2::score | ( | ) |  |

virtual

Returns the score of the current document matching the query. Initially invalid, until nextDoc() or advance(int32_t) is called the first time, or when called from within Collector#collect.

Implements Lucene::Scorer.

boost::shared_ptr< BooleanScorer2 > Lucene::BooleanScorer2::shared_from_this | ( | ) |  |

inline

## Field Documentation

CoordinatorPtr Lucene::BooleanScorer2::coordinator

protected

ScorerPtr Lucene::BooleanScorer2::countingSumScorer

protected

The scorer to which all scoring will be delegated, except for computing and using the coordination factor.

int32_t Lucene::BooleanScorer2::doc

protected

int32_t Lucene::BooleanScorer2::minNrShouldMatch

protected

Collection<ScorerPtr> Lucene::BooleanScorer2::optionalScorers

protected

Collection<ScorerPtr> Lucene::BooleanScorer2::prohibitedScorers

protected

Collection<ScorerPtr> Lucene::BooleanScorer2::requiredScorers

protected

The documentation for this class was generated from the following file:

- BooleanScorer2.h

clucene.sourceforge.net